SuperStrict

Framework brl.basic

' imports
Import brl.d3d9max2d
Import brl.Pixmap
Import brl.pngloader
Import brl.tgaloader
Import brl.jpgloader
Import brl.bmploader
Import brl.retro
Import brl.timer
Import maxgui.Drivers

Const TITLE:String = "Normalmap Generator 1.0 by Krischan"
apptitle=TITLE


' Variables to change
Global VAR_BLURRANGE1:Int = 16                 ' Large Blur
Global VAR_BLURRANGE2:Int = 4                 ' Medium Blur
Global VAR_BLURRANGE3:Int = 1                 ' Slight Blur
Global VAR_NORMALSTRENGTH1:Int = 4            ' N1 (Large Detail)
Global VAR_NORMALSTRENGTH2:Int = 2            ' N2 (Medium Detail)
Global VAR_NORMALSTRENGTH3:Int = 1            ' N3 (Fine Detail)
Global VAR_NORMALSTRENGTH4:Int = 1            ' N4 (Finest Detail)
Global BLENDMODEA:Int = 0                     ' Filter for blending (N1+N2) = (Large+Medium)
Global BLENDMODEB:Int = 0                     ' Filter for blending (N1+N2)+N3 = (Large+Medium)+Fine
Global BLENDMODEC:Int = 1                     ' Filter for blending (N1+N2+N3)+N4 = (Large+Medium+Fine)+Finest
Global DESATURATE:Int = 1                     ' Desaturation Mode: "Average" or "Luminosity"


' Menu constants
Const MENU_EXIT:Int = 0
Const MENU_IMPORT:Int = 1
Const MENU_EXPORT:Int = 2
Const MENU_EXPORTFAST:Int = 3
Const MENU_INVERT:Int = 10
Const MENU_ABOUT:Int = 10


' MAXGUI main gadgets
Global MAXGUI_WINDOW:TGadget
Global MAXGUI_CANVAS:TGadget
Global MAXGUI_PANEL:TGadget
Global MAXGUI_PANEL_BUMPMAP:TGadget
Global MAXGUI_PANEL_NORMALMAP:TGadget
Global MAXGUI_PANEL_BLENDING:TGadget
Global MAXGUI_PANEL_BUTTON:TGadget


' MAXGUI Bumpmap Sliders
Global MAXGUI_PANEL_BUMPSELECTION:TGadget
Global MAXGUI_PANEL_BUMPSLIDER1:TGadget
Global MAXGUI_PANEL_BUMPSLIDER2:TGadget
Global MAXGUI_PANEL_BUMPSLIDER3:TGadget
Global MAXGUI_PANEL_BUMPVALUE1:TGadget
Global MAXGUI_PANEL_BUMPVALUE2:TGadget
Global MAXGUI_PANEL_BUMPVALUE3:TGadget


' MAXGUI Normalmap Sliders
Global MAXGUI_PANEL_NORMALSLIDER1:TGadget
Global MAXGUI_PANEL_NORMALSLIDER2:TGadget
Global MAXGUI_PANEL_NORMALSLIDER3:TGadget
Global MAXGUI_PANEL_NORMALSLIDER4:TGadget
Global MAXGUI_PANEL_NORMALVALUE1:TGadget
Global MAXGUI_PANEL_NORMALVALUE2:TGadget
Global MAXGUI_PANEL_NORMALVALUE3:TGadget
Global MAXGUI_PANEL_NORMALVALUE4:TGadget


' MAXGUI Blending Selections
Global MAXGUI_PANEL_BLENDSELECTION1:TGadget
Global MAXGUI_PANEL_BLENDSELECTION2:TGadget
Global MAXGUI_PANEL_BLENDSELECTION3:TGadget
Global MAXGUI_PANEL_BLENDSELECTION4:TGadget


' MAXGUI Menus
Global MAXGUI_MENU:TGadget
Global MAXGUI_OPTIONS:TGadget
Global MAXGUI_HELP:TGadget
Global MAXGUI_ABOUT:TGadget
Global MAXGUI_IMPORT:TGadget
Global MAXGUI_EXPORT:TGadget
Global MAXGUI_INVERT:TGadget


' MAXGUI other
Global MAXGUI_PROGRESS:TGadget
Global MAXGUI_TIMER:TTimer = CreateTimer(60)


' Resolutions
Global SCREEN_DESKTOPWIDTH:Int = DesktopWidth()
Global SCREEN_DESKTOPHEIGHT:Int = DesktopHeight()
Global SCREEN_CENTERX:Int = SCREEN_DESKTOPWIDTH / 2
Global SCREEN_CENTERY:Int = SCREEN_DESKTOPHEIGHT / 2
Global WINDOW_WIDTH:Int = 768'SCREEN_DESKTOPWIDTH / 2
Global WINDOW_HEIGHT:Int = 768'SCREEN_DESKTOPHEIGHT / 2


' Other vars
Global FILE:String
Global EXPORT:String
Global INVERT:Int = 0
Global MX:Int = 0
Global MN:Int = 255
Global W:Int
Global H:Int
Global PROGRESS:Int
Global PROGRESSMAX:Int
Global PX:TPixmap
Global MS:Int
Global Blendmodes:String[] = ["Softlight", "Hardlight", "Overlay"]
Global Desaturatemodes:String[] = ["Average", "Luminosity"]
Global VAR_BLENDMODEA:String
Global VAR_BLENDMODEB:String
Global VAR_BLENDMODEC:String
Global VAR_DESATUREMODE:String



' ----------------------------------------------------------------------------
' Initialize MAXGUI environment
' ----------------------------------------------------------------------------

' Create maxgui Window
MAXGUI_WINDOW = CreateWindow(TITLE, SCREEN_CENTERX - WINDOW_WIDTH + 300 / 2, SCREEN_CENTERY - WINDOW_HEIGHT / 2, WINDOW_WIDTH + 300, WINDOW_HEIGHT, Null, WINDOW_TITLEBAR | WINDOW_MENU | WINDOW_STATUS | WINDOW_CLIENTCOORDS)

' Create MAXGUI Canvas
MAXGUI_CANVAS = CreateCanvas(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, MAXGUI_WINDOW)
SetGadgetLayout MAXGUI_CANVAS, 1, 1, 1, 1
ActivateGadget(MAXGUI_CANVAS)
SetGraphics CanvasGraphics(MAXGUI_CANVAS)

' Create MAXGUI Panels
MAXGUI_PANEL = CreatePanel(WINDOW_WIDTH + 1, 0, 298, WINDOW_HEIGHT, MAXGUI_WINDOW, PANEL_SUNKEN)
MAXGUI_PANEL_BUMPMAP = CreatePanel(10, 10, 280, 190, MAXGUI_PANEL, PANEL_GROUP, "Gaussian Blur")
MAXGUI_PANEL_NORMALMAP = CreatePanel(10, 210, 280, 200, MAXGUI_PANEL, PANEL_GROUP, "Normalmap Strength")
MAXGUI_PANEL_BLENDING = CreatePanel(10, 420, 280, 200, MAXGUI_PANEL, PANEL_GROUP, "Normalmap Blending")
MAXGUI_PANEL_BUTTON = CreateButton("Recalculate Normalmap~nwith these values", 10, 630, 280, 130, MAXGUI_PANEL)

' Create MAXGUI Bumpmap Panel Sliders
CreateLabel("Large Detail", 10, 19, 80, 20, MAXGUI_PANEL_BUMPMAP)
CreateLabel("Medium Detail", 10, 59, 80, 20, MAXGUI_PANEL_BUMPMAP)
CreateLabel("Fine Detail", 10, 99, 80, 20, MAXGUI_PANEL_BUMPMAP)
CreateLabel("Desaturation Filter", 10, 141, 110, 20, MAXGUI_PANEL_BUMPMAP)
MAXGUI_PANEL_BUMPSELECTION = CreateComboBox(137, 137, 127, 24, MAXGUI_PANEL_BUMPMAP)
AddGadgetItem(MAXGUI_PANEL_BUMPSELECTION, Desaturatemodes[0])
AddGadgetItem(MAXGUI_PANEL_BUMPSELECTION, Desaturatemodes[1])
MAXGUI_PANEL_BUMPSLIDER1 = CreateSlider(130, 13, 140, 30, MAXGUI_PANEL_BUMPMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_BUMPSLIDER2 = CreateSlider(130, 53, 140, 30, MAXGUI_PANEL_BUMPMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_BUMPSLIDER3 = CreateSlider(130, 93, 140, 30, MAXGUI_PANEL_BUMPMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_BUMPVALUE1 = CreateTextField(100, 16, 32, 24, MAXGUI_PANEL_BUMPMAP)
MAXGUI_PANEL_BUMPVALUE2 = CreateTextField(100, 56, 32, 24, MAXGUI_PANEL_BUMPMAP)
MAXGUI_PANEL_BUMPVALUE3 = CreateTextField(100, 96, 32, 24, MAXGUI_PANEL_BUMPMAP)
SetSliderRange(MAXGUI_PANEL_BUMPSLIDER1, 0, 25)
SetSliderRange(MAXGUI_PANEL_BUMPSLIDER2, 0, 25)
SetSliderRange(MAXGUI_PANEL_BUMPSLIDER3, 0, 25)
SelectGadgetItem(MAXGUI_PANEL_BUMPSELECTION, 0)

' Create MAXGUI Normalmap Panel Sliders
CreateLabel("Large Detail", 10, 19, 80, 30, MAXGUI_PANEL_NORMALMAP)
CreateLabel("Medium Detail", 10, 59, 80, 30, MAXGUI_PANEL_NORMALMAP)
CreateLabel("Fine Detail", 10, 92, 89, 30, MAXGUI_PANEL_NORMALMAP)
CreateLabel("Finest Detail", 10, 139, 80, 30, MAXGUI_PANEL_NORMALMAP)
MAXGUI_PANEL_NORMALSLIDER1 = CreateSlider(130, 13, 140, 30, MAXGUI_PANEL_NORMALMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_NORMALSLIDER2 = CreateSlider(130, 53, 140, 30, MAXGUI_PANEL_NORMALMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_NORMALSLIDER3 = CreateSlider(130, 93, 140, 30, MAXGUI_PANEL_NORMALMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_NORMALSLIDER4 = CreateSlider(130, 133, 140, 30, MAXGUI_PANEL_NORMALMAP, SLIDER_HORIZONTAL | SLIDER_TRACKBAR)
MAXGUI_PANEL_NORMALVALUE1 = CreateTextField(100, 16, 32, 24, MAXGUI_PANEL_NORMALMAP)
MAXGUI_PANEL_NORMALVALUE2 = CreateTextField(100, 56, 32, 24, MAXGUI_PANEL_NORMALMAP)
MAXGUI_PANEL_NORMALVALUE3 = CreateTextField(100, 96, 32, 24, MAXGUI_PANEL_NORMALMAP)
MAXGUI_PANEL_NORMALVALUE4 = CreateTextField(100, 136, 32, 24, MAXGUI_PANEL_NORMALMAP)
SetSliderRange(MAXGUI_PANEL_NORMALSLIDER1, 0, 25)
SetSliderRange(MAXGUI_PANEL_NORMALSLIDER2, 0, 25)
SetSliderRange(MAXGUI_PANEL_NORMALSLIDER3, 0, 25)
SetSliderRange(MAXGUI_PANEL_NORMALSLIDER4, 0, 25)

' Create MAXGUI Blending Selections
CreateLabel("Blendmode: (Large+Medium)", 10, 10, 255, 20, MAXGUI_PANEL_BLENDING)
CreateLabel("Blendmode: (Large+Medium)+Fine", 10, 65, 255, 20, MAXGUI_PANEL_BLENDING)
CreateLabel("Blendmode: (Large+Medium+Fine)+Finest", 10, 120, 255, 20, MAXGUI_PANEL_BLENDING)
MAXGUI_PANEL_BLENDSELECTION1 = CreateComboBox(10, 30, 255, 24, MAXGUI_PANEL_BLENDING)
MAXGUI_PANEL_BLENDSELECTION2 = CreateComboBox(10, 85, 255, 24, MAXGUI_PANEL_BLENDING)
MAXGUI_PANEL_BLENDSELECTION3 = CreateComboBox(10, 140, 255, 24, MAXGUI_PANEL_BLENDING)
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION1, Blendmodes[0])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION1, Blendmodes[1])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION1, Blendmodes[2])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION2, Blendmodes[0])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION2, Blendmodes[1])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION2, Blendmodes[2])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION3, Blendmodes[0])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION3, Blendmodes[1])
AddGadgetItem(MAXGUI_PANEL_BLENDSELECTION3, Blendmodes[2])
SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION1, 0)
SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION2, 0)
SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION3, 1)


' File Menu
MAXGUI_MENU = CreateMenu("File", 0, WindowMenu(MAXGUI_WINDOW))
MAXGUI_IMPORT = AddMenu("Import Texture", MAXGUI_MENU, MENU_IMPORT, Null, Null, Null, False)
MAXGUI_EXPORT = AddMenu("Export Normalmap", MAXGUI_MENU, MENU_EXPORT, Null, Null, Null, False)
AddMenu("Exit", MAXGUI_MENU, MENU_EXIT, Null, Null, Null, False)

' Options Menu
MAXGUI_OPTIONS = CreateMenu("Options", 0, WindowMenu(MAXGUI_WINDOW))
MAXGUI_INVERT = AddMenu("Invert Bumpmap", MAXGUI_OPTIONS, MENU_INVERT, Null, Null, Null, False)

' About Menu
MAXGUI_HELP = CreateMenu("Help", 0, WindowMenu(MAXGUI_WINDOW))
MAXGUI_ABOUT = AddMenu("About", MAXGUI_HELP, MENU_ABOUT, Null, Null, Null, False)

UpdateWindowMenu MAXGUI_WINDOW

' Progress Bar
MAXGUI_PROGRESS = CreateProgBar(WINDOW_WIDTH / 2 - 100, WINDOW_HEIGHT / 2 - 10, 200, 20, MAXGUI_CANVAS)
HideGadget MAXGUI_PROGRESS

' disable export and show default text in status bar
DisableMenu MAXGUI_EXPORT
SetStatusText(MAXGUI_WINDOW, "Import a texture from the File menu first.")

UpdatePanel()

AddHook EmitEventHook, LoopHook



' ----------------------------------------------------------------------------
' Loop Hook
' ----------------------------------------------------------------------------
Function LoopHook:Object(id:Int, data:Object, context:Object)

	Local Event:TEvent = TEvent(data)
	If Event = Null Then Return Event

	Select Event.id

		Case EVENT_WINDOWCLOSE
			End

		Case EVENT_APPTERMINATE
			End

		Case EVENT_TIMERTICK

			Select Event.Source

				Case MAXGUI_TIMER
	
					RedrawGadget MAXGUI_CANVAS
					GCCollect()

			End Select

		Case EVENT_MOUSEDOWN

				Local MouseButton:Int = Event.data
				
				If MouseButton = 1 Then VirtualClick(MENU_IMPORT)
				If MouseButton = 2 And FILE <> "" Then VirtualClick(MENU_EXPORTFAST)
				
				MouseButton = Null
			
		Case EVENT_GADGETACTION
		
				Select Event.source
				
					Case MAXGUI_PANEL_BUTTON
						If TPixmap(PX) Then Recalculate()
				
					Case MAXGUI_PANEL_BUMPSLIDER1
						VAR_BLURRANGE1 = SliderValue(MAXGUI_PANEL_BUMPSLIDER1)
						
					Case MAXGUI_PANEL_BUMPSLIDER2
						VAR_BLURRANGE2 = SliderValue(MAXGUI_PANEL_BUMPSLIDER2)
						
					Case MAXGUI_PANEL_BUMPSLIDER3
						VAR_BLURRANGE3 = SliderValue(MAXGUI_PANEL_BUMPSLIDER3)
				
					Case MAXGUI_PANEL_BUMPVALUE1
						VAR_BLURRANGE1 = Clamp(Int(GadgetText(MAXGUI_PANEL_BUMPVALUE1)), 0, 25)
						
					Case MAXGUI_PANEL_BUMPVALUE2
						VAR_BLURRANGE2 = Clamp(Int(GadgetText(MAXGUI_PANEL_BUMPVALUE2)), 0, 25)

					Case MAXGUI_PANEL_BUMPVALUE3
						VAR_BLURRANGE3 = Clamp(Int(GadgetText(MAXGUI_PANEL_BUMPVALUE3)), 0, 25)

					Case MAXGUI_PANEL_BUMPSELECTION
						DESATURATE = SelectedGadgetItem(MAXGUI_PANEL_BUMPSELECTION)
						
					Case MAXGUI_PANEL_NORMALSLIDER1
						VAR_NORMALSTRENGTH1 = SliderValue(MAXGUI_PANEL_NORMALSLIDER1)
						
					Case MAXGUI_PANEL_NORMALSLIDER2
						VAR_NORMALSTRENGTH2 = SliderValue(MAXGUI_PANEL_NORMALSLIDER2)
						
					Case MAXGUI_PANEL_NORMALSLIDER3
						VAR_NORMALSTRENGTH3 = SliderValue(MAXGUI_PANEL_NORMALSLIDER3)
				
					Case MAXGUI_PANEL_NORMALSLIDER4
						VAR_NORMALSTRENGTH4 = SliderValue(MAXGUI_PANEL_NORMALSLIDER4)

					Case MAXGUI_PANEL_NORMALVALUE1
						VAR_NORMALSTRENGTH1 = Clamp(Int(GadgetText(MAXGUI_PANEL_NORMALVALUE1)), 0, 25)
						
					Case MAXGUI_PANEL_NORMALVALUE2
						VAR_NORMALSTRENGTH2 = Clamp(Int(GadgetText(MAXGUI_PANEL_NORMALVALUE2)), 0, 25)

					Case MAXGUI_PANEL_NORMALVALUE3
						VAR_NORMALSTRENGTH3 = Clamp(Int(GadgetText(MAXGUI_PANEL_NORMALVALUE3)), 0, 25)
					
					Case MAXGUI_PANEL_NORMALVALUE4
						VAR_NORMALSTRENGTH4 = Clamp(Int(GadgetText(MAXGUI_PANEL_NORMALVALUE4)), 0, 25)

					Case MAXGUI_PANEL_BLENDSELECTION1
						BLENDMODEA = SelectedGadgetItem(MAXGUI_PANEL_BLENDSELECTION1)

					Case MAXGUI_PANEL_BLENDSELECTION2
						BLENDMODEB = SelectedGadgetItem(MAXGUI_PANEL_BLENDSELECTION2)

					Case MAXGUI_PANEL_BLENDSELECTION3
						BLENDMODEC = SelectedGadgetItem(MAXGUI_PANEL_BLENDSELECTION3)

				End Select
				
				UpdatePanel()
				
		Case EVENT_MENUACTION

			Select Event.data

				Case MENU_EXIT

					End
					
				Case MENU_ABOUT
				
					Notify("(C) 2018 by Christian Hart (Krischan)~nWritten in the great Blitzmax language.~nUses MAXGUI and Gaussian Blur routines by Queller.~nContact me at www.syntaxbomb.com~n~nThis little tool creates a fake Normalmap from a single diffuse Texture input using a Gaussian Blur filter. You can select the Blurranges, Normalstrengths and Blendmodes on the right side. The result can be exported as a TGA 24bit file. A quick Import/Export mode is available using the two Mousebuttons on the Canvas.~n~nHow it works:~nThe input Texture will be desaturated and copied three times. Then, three Gaussian Blur filters with different ranges are applied to each of them. After that, the three Bumpmaps are converted into Normalmaps with different strengths and are blended together with an unblurred version of the desaturated original Texture.~n~nHave fun with it.")
	
				Case MENU_IMPORT
	
					FILE = RequestFile("Import Texture", "Image Files (TGA,PNG,JPG,BMP):tga,png,jpg,bmp;")
	
					If FILE <> "" Then

						Recalculate()

					Else

						Cls
						Flip

						FILE = Null
						PX = Null
						DisableMenu MAXGUI_EXPORT
						SetStatusText(MAXGUI_WINDOW, "Import a texture from the FILE menu First.")

					EndIf
	
				Case MENU_EXPORT
	
					Local f:String = StripAll(FILE) + "_NRM"
	
					EXPORT = RequestFile("Export Normalmap", "TGA 24bit:tga;", True, f)
	
					If EXPORT <> "" Then VirtualClick(MENU_EXPORTFAST)
	
	
				Case MENU_EXPORTFAST
	
					EXPORT = ExtractDir(FILE) + "/" + StripAll(FILE) + "_NRM.tga"
					SavePixmapTGA(PX, EXPORT, 24)
					Notify("Normalmap saved to " + EXPORT)

				Case MENU_INVERT
	
					INVERT = 1 - INVERT

					If (INVERT) Then
	
						CheckMenu(MAXGUI_INVERT)

					Else
	
						UncheckMenu (MAXGUI_INVERT)

					EndIf

					If FILE <> "" Then
	
						Recalculate()

					Else
	
						Cls
						Flip

						FILE = Null
						PX = Null
						DisableMenu MAXGUI_EXPORT
						SetStatusText(MAXGUI_WINDOW, "Import a texture from the FILE menu First.")

					EndIf
					
			End Select

	End Select

End Function



' ----------------------------------------------------------------------------
' Main Loop
' ----------------------------------------------------------------------------
While Not AppTerminate()

	Cls
	
	SetBlend ALPHABLEND
	
	' draw checker board background
	Local s:Float = WINDOW_WIDTH / 16.0
	Local v:Int = 0
	SetAlpha(0.125)
	For Local x:Int = 0 To 15
	
		For Local y:Int = 0 To 15
		
			v = 1 - v
			If v = 0 Then SetColor(255, 255, 255) Else SetColor(128, 128, 128)
			
			DrawRect(x * s, y * s, s, s)
			
		Next
		
		v = 1 - v
		
	Next
		
	' draw final map if available
	If TPixmap(PX) Then
	
		SetAlpha(1.0)
		DrawPixmapAspect(PX, WINDOW_WIDTH, WINDOW_HEIGHT)
		
	EndIf
	
	' text notice
	SetAlpha(1.0)
	SetColor(0, 255, 0)
	Local t1:String = "Left click on background to quickload a texture"
	Local t2:String = "Right click on background to quicksave the normalmap"
	DrawShadowText(t1, WINDOW_HEIGHT / 2 - TextWidth(t1) / 2, WINDOW_HEIGHT - TextHeight(t1) * 2)
	DrawShadowText(t2, WINDOW_HEIGHT / 2 - TextWidth(t2) / 2, WINDOW_HEIGHT - TextHeight(t2) * 1)
	
	Flip

Wend

End



Function Recalculate()

	MX = 0
	MN = 255

	PX = LoadPixmap(FILE)
	
	If TPixmap(PX) Then

		Cls
		Flip
	
		ShowGadget MAXGUI_PROGRESS
	
		W = PX.width
		H = PX.Height
	
		PROGRESS = 0
		PROGRESSMAX = W * (10 + (H * 1.0 / W * 3))
	
		MS = MilliSecs()
	
		Desaturation(PX)
		Normalization(PX)
		CreateNormalmap(PX, INVERT)
	
		SetStatusText(MAXGUI_WINDOW, "Finished in " + (MilliSecs() - MS) + "ms. The Normalmap can be exported from the file menu now.")
	
		HideGadget MAXGUI_PROGRESS
		EnableMenu MAXGUI_EXPORT
		
	Else	

		Cls
		Flip

		Notify("ERROR loading file " + FILE + "!")
		FILE = Null
		PX = Null
		DisableMenu MAXGUI_EXPORT
		SetStatusText(MAXGUI_WINDOW, "Import a texture from the File menu first.")
	
	EndIf

End Function


' ----------------------------------------------------------------------------
' Update Variables and Panel Sliders / Textfields vice versa
' ----------------------------------------------------------------------------
Function UpdatePanel()

	SetSliderValue(MAXGUI_PANEL_BUMPSLIDER1, VAR_BLURRANGE1)
	SetSliderValue(MAXGUI_PANEL_BUMPSLIDER2, VAR_BLURRANGE2)
	SetSliderValue(MAXGUI_PANEL_BUMPSLIDER3, VAR_BLURRANGE3)
	
	SetGadgetText(MAXGUI_PANEL_BUMPVALUE1, VAR_BLURRANGE1)
	SetGadgetText(MAXGUI_PANEL_BUMPVALUE2, VAR_BLURRANGE2)
	SetGadgetText(MAXGUI_PANEL_BUMPVALUE3, VAR_BLURRANGE3)
	
	SelectGadgetItem(MAXGUI_PANEL_BUMPSELECTION, DESATURATE)
	
	SetSliderValue(MAXGUI_PANEL_NORMALSLIDER1, VAR_NORMALSTRENGTH1)
	SetSliderValue(MAXGUI_PANEL_NORMALSLIDER2, VAR_NORMALSTRENGTH2)
	SetSliderValue(MAXGUI_PANEL_NORMALSLIDER3, VAR_NORMALSTRENGTH3)
	SetSliderValue(MAXGUI_PANEL_NORMALSLIDER4, VAR_NORMALSTRENGTH4)
	
	SetGadgetText(MAXGUI_PANEL_NORMALVALUE1, VAR_NORMALSTRENGTH1)
	SetGadgetText(MAXGUI_PANEL_NORMALVALUE2, VAR_NORMALSTRENGTH2)
	SetGadgetText(MAXGUI_PANEL_NORMALVALUE3, VAR_NORMALSTRENGTH3)
	SetGadgetText(MAXGUI_PANEL_NORMALVALUE4, VAR_NORMALSTRENGTH4)

	SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION1, BLENDMODEA)
	SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION2, BLENDMODEB)
	SelectGadgetItem(MAXGUI_PANEL_BLENDSELECTION3, BLENDMODEC)
	
	VAR_BLENDMODEA = Blendmodes[BLENDMODEA]
	VAR_BLENDMODEB = Blendmodes[BLENDMODEB]
	VAR_BLENDMODEC = Blendmodes[BLENDMODEC]
	VAR_DESATUREMODE = Desaturatemodes[DESATURATE]

End Function



' ----------------------------------------------------------------------------
' Simulated click on a menu id
' ----------------------------------------------------------------------------
Function VirtualClick(menu:Int)

	EmitEvent(CreateEvent(EVENT_MENUACTION, Null, menu, 0, 0, 0, Null))

End Function



' ----------------------------------------------------------------------------
' Draw Pixmap centered considering the aspect ratio
' ----------------------------------------------------------------------------
Function DrawPixmapAspect(pixmap:TPixmap, w:Int = 512, h:Int = 512)

	Local aspect:Float = pixmap.width * 1.0 / pixmap.Height * (WINDOW_HEIGHT * 1.0 / WINDOW_WIDTH)
	Local pw:Int
	Local ph:Int

	If aspect < 1 Then
	
		pw = WINDOW_WIDTH * aspect
		ph = WINDOW_HEIGHT

	Else
	
		pw = WINDOW_WIDTH
		ph = WINDOW_HEIGHT / aspect

	EndIf
	
	DrawPixmap(ResizePixmap(CopyPixmap(pixmap), pw, ph), (WINDOW_WIDTH - pw) / 2, (WINDOW_HEIGHT - ph) / 2)

End Function


' ----------------------------------------------------------------------------
' help function to add MAXGUI menu entries
' ----------------------------------------------------------------------------
Function AddMenu:TGadget(title:String, menu:TGadget, constant:Int, icon:Int, iconstrip:TIconStrip, shortcut:Int, modifier:Int)

	Local gadget:TGadget = CreateMenu(title, constant, menu, shortcut, modifier)

	Return gadget

End Function



' ----------------------------------------------------------------------------
' Desaturate Pixmap (two modes: Average and Luminosity)
' ----------------------------------------------------------------------------
Function Desaturation(pixmap:TPixmap, modus:String = "Luminosity")

	For Local x:Int = 0 To pixmap.width - 1

		For Local y:Int = 0 To pixmap.Height - 1

			Local rgb:Int = ReadPixel(pixmap, x, y)
			Local a:Int = GetA(rgb)
			Local c:Int = Greyscale(getR(rgb), getg(rgb), getb(rgb), modus)
	
			If c > MX Then MX = c
			If c < MN Then MN = c
	
			WritePixel(pixmap, x, y, CombineRGBA(c, c, c, a))

		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next

End Function



' ----------------------------------------------------------------------------
' Normalize Pixmap using Min/Max values determined in Desaturation function
' ----------------------------------------------------------------------------
Function Normalization(pixmap:TPixmap)

	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			Local rgb:Int = ReadPixel(pixmap, x, y)
			Local c:Int = Normalize(getR(rgb), mn, mx, 0, 255)
			Local a:Int = GetA(rgb)
	
			WritePixel(pixmap, x, y, CombineRGBA(c, c, c, a))
	
		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next

End Function



' ----------------------------------------------------------------------------
' Creates four normalmaps and blends them together to the final
' ----------------------------------------------------------------------------
Function CreateNormalmap(pixmap:TPixmap, invert:Int = False)

	' always convert bumpmap to RGBA first
	PX = ConvertPixmap(pixmap, PF_RGBA8888)

	' copy RGBA bumpmap for blur processing
	Local pix1:TPixmap = CopyPixmap(px)
	Local pix2:TPixmap = CopyPixmap(px)
	Local pix3:TPixmap = CopyPixmap(px)
	
	' create RGB normalmaps
	Local nrm1:TPixmap = CreatePixmap(px.width, px.Height, PF_RGB888)
	Local nrm2:TPixmap = CreatePixmap(px.width, px.Height, PF_RGB888)
	Local nrm3:TPixmap = CreatePixmap(px.width, px.Height, PF_RGB888)
	Local nrm4:TPixmap = CreatePixmap(px.width, px.Height, PF_RGB888)

	' slightly blur the third bumpmap
	SetStatusText(MAXGUI_WINDOW, "Gaussian Blur of 3rd Bumpmap (slight)")
	pix3 = GaussianBlur(pix3, VAR_BLURRANGE3)
	DrawPixmapAspect(pix3, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip
	
	' medium blur of second bumpmap
	SetStatusText(MAXGUI_WINDOW, "Gaussian Blur of 2nd Bumpmap (medium)")
	pix2 = GaussianBlur(pix2, VAR_BLURRANGE2)
	DrawPixmapAspect(pix2, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip
	
	' heavy blur of first bumpmap
	SetStatusText(MAXGUI_WINDOW, "Gaussian Blur of 1st Bumpmap (heavy)")
	pix1 = GaussianBlur(pix1, VAR_BLURRANGE1)
	DrawPixmapAspect(pix1, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip

	' calculate first Normalmap
	SetStatusText(MAXGUI_WINDOW, "Calculate 1st Normalmap")
	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			WritePixel(nrm1, x, y, CalcNormal(pix1, x, y, VAR_NORMALSTRENGTH1, INVERT))

		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next
	DrawPixmapAspect(nrm1, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip
	
	' calculate second Normalmap
	SetStatusText(MAXGUI_WINDOW, "Calculate 2nd Normalmap")
	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			WritePixel(nrm2, x, y, CalcNormal(pix2, x, y, VAR_NORMALSTRENGTH2, INVERT))

		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next
	DrawPixmapAspect(nrm2, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip
	
	' calculate third Normalmap
	SetStatusText(MAXGUI_WINDOW, "Calculate 3rd Normalmap")
	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			WritePixel(nrm3, x, y, CalcNormal(pix3, x, y, VAR_NORMALSTRENGTH3, INVERT))

		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next
	DrawPixmapAspect(nrm3, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip
	
	' calculate fourth Normalmap
	SetStatusText(MAXGUI_WINDOW, "Calculate 4th Normalmap")
	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			WritePixel(nrm4, x, y, CalcNormal(PX, x, y, VAR_NORMALSTRENGTH4, INVERT))

		Next

		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next
	DrawPixmapAspect(nrm4, WINDOW_WIDTH, WINDOW_HEIGHT)
	Flip

	' blend all four normalmaps together
	SetStatusText(MAXGUI_WINDOW, "Calculate Final Normalmap")
	For Local x:Int = 0 To pixmap.width - 1
	
		For Local y:Int = 0 To pixmap.Height - 1

			Local rgb1:Int = ReadPixel(nrm1, x, y)
			Local rgb2:Int = ReadPixel(nrm2, x, y)
			Local rgb3:Int = ReadPixel(nrm3, x, y)
			Local rgb4:Int = ReadPixel(nrm4, x, y)
	
			Local r1:Int = GetR(rgb1)
			Local g1:Int = GetG(rgb1)
			Local b1:Int = GetB(rgb1)
	
			Local r2:Int = GetR(rgb2)
			Local g2:Int = GetG(rgb2)
			Local b2:Int = GetB(rgb2)
	
			Local r3:Int = GetR(rgb3)
			Local g3:Int = GetG(rgb3)
			Local b3:Int = GetB(rgb3)
	
			Local r4:Int = GetR(rgb4)
			Local g4:Int = GetG(rgb4)
			Local b4:Int = GetB(rgb4)
	
			Local r:Int
			Local g:Int
			Local b:Int
	
			' blend 1st normalmap with 2nd normalmap
			r = Filter(r1, r2, VAR_BLENDMODEA)
			g = Filter(g1, g2, VAR_BLENDMODEA)
			b = Filter(b1, b2, VAR_BLENDMODEA)
	
			' blend the normalmap with the 3rd normalmap
			r = Filter(r3, r, VAR_BLENDMODEB)
			g = Filter(g3, g, VAR_BLENDMODEB)
			b = Filter(b3, b, VAR_BLENDMODEB)
	
			' blend the normalmap with the 4th normalmap
			r = Filter(r4, r, VAR_BLENDMODEC)
			g = Filter(g4, g, VAR_BLENDMODEC)
			b = Filter(b4, b, VAR_BLENDMODEC)
	
			WritePixel(PX, x, y, CombineRGB(r, g, b))
	
		Next
	
		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

	Next
	
End Function



' ----------------------------------------------------------------------------
' Gaussian Blur Call
' ----------------------------------------------------------------------------
Function GaussianBlur:TPixmap(tex:TPixmap, radius:Int)

	If radius <= 0 Return tex
	
	'clone incoming texture
	Local texclone:TPixmap = tex.Copy()
	
	'instantiate a new gaussian filter
	Local filter:TGaussianFilter = New TGaussianFilter
	
	'configure it
	Filter.radius = radius
	
	Return Filter.Apply(tex, texclone)
	
End Function



' ----------------------------------------------------------------------------
' Gaussian Blur Type
' ----------------------------------------------------------------------------
Type TGaussianFilter

	Field radius:Double
	Field kernel:TKernel
	
	' apply Gaussian Blur to pixmap
	Method Apply:TPixmap(src:TPixmap, dst:TPixmap)
	
		Self.kernel = makekernel(Self.radius)
		Self.convolveAndTranspose(Self.kernel, src, dst, PixmapWidth(src), PixmapHeight(src), True)
		Self.convolveAndTranspose(Self.kernel, dst, src, PixmapHeight(dst), PixmapWidth(dst), True)

		dst = Null

		GCCollect()

		Return src

	End Method

	' Make a Gaussian blur kernel
	Method makekernel:TKernel(radius:Double)
	
		Local r:Int = Int(Ceil(radius))
		Local rows:Int = r * 2 + 1
		Local matrix:Double[] = New Double[rows]
		Local sigma:Double = radius / 3.0
		Local sigma22:Double = 2 * sigma * sigma
		Local sigmaPi2:Double = 2 * Pi * sigma
		Local sqrtSigmaPi2:Double = Double(Sqr(sigmaPi2))
		Local radius2:Double = radius * radius
		Local total:Double = 0
		Local index:Int = 0

		For Local row:Int = -r To r

			Local distance:Double = Double(row * row)
	
			If (distance > radius2) Then
	
				matrix[index] = 0

			Else
	
				matrix[index] = Double(Exp(-(distance / sigma22)) / sqrtSigmaPi2)
				total:+matrix[index]
				index:+1

			End If
	
		Next

		For Local i:Int = 0 Until rows

			'normalizes the gaussian kernel
			matrix[i] = matrix[i] / total
	
		Next

		Return mkernel(rows, 1, matrix)

	End Method
	
	' return function for makekernel
	Function mkernel:TKernel(w:Int, h:Int, d:Double[])
	
		Local k:TKernel = New TKernel

		k.width = W
		k.Height = H
		k.data = d
	
		Return k

	End Function

	' Convolve Gaussian Blur
	Method ConvolveAndTranspose(kernel:TKernel, in:TPixmap, out:TPixmap, width:Int, Height:Int, Alpha:Int)
	
		Local inba:Byte Ptr = in.Pixels
		Local outba:Byte Ptr = out.Pixels

		Local matrix:Double[] = kernel.getKernelData()

		Local cols:Int = kernel.GetWidth()
		Local cols2:Int = cols / 2

		For Local y:Int = 0 Until Height

			Local index:Int = y
	
			Local ioffset:Int = y * width
	
			For Local x:Int = 0 Until width

				Local r:Double = 0, g:Double = 0, b:Double = 0, a:Double = 0
				Local moffset:Int = cols2
	
				For Local col:Int = -cols2 To cols2
	
					Local f:Double = matrix[moffset + col]
	
					If (f <> 0) Then

						Local ix:Int = x + col

						If (ix < 0) Then
	
							ix = 0

						Else If (ix >= width)
	
							ix = width - 1

						End If
	
						Local rgb:Int = (Int Ptr inba)[ioffset + ix]
						a:+f * ((rgb Shr 24) & $FF)
						b:+f * ((rgb Shr 16) & $FF)
						g:+f * ((rgb Shr 8) & $FF)
						r:+f * (rgb & $FF)

					End If

		Next

		Local ia:Int

		If Alpha = True Then ia = ClampColor(Int(a + 0.5)) Else ia = $FF

		Local ir:Int = ClampColor(Int(r + 0.5))
		Local ig:Int = ClampColor(Int(g + 0.5))
		Local ib:Int = ClampColor(Int(b + 0.5))

			(Int Ptr outba)[index] = ((ia Shl 24) | (ib Shl 16) | (ig Shl 8) | (ir Shl 0))

		index:+Height

		Next
	
		PROGRESS:+1
		UpdateProgBar(MAXGUI_PROGRESS, PROGRESS * 1.0 / PROGRESSMAX)

		Next

	End Method
	
End Type



' ----------------------------------------------------------------------------
' Gaussian Blur Kernel
' ----------------------------------------------------------------------------
Type TKernel

	Field width:Int
	Field Height:Int
	Field data:Double[]
	
	Method getkerneldata:Double[] ()
	
		Return Self.data

	End Method
	
	Method GetWidth:Int()
	
		Return Self.width

	End Method
	
	Method GetHeight:Int()
	
		Return Self.Height

	End Method

End Type



' ----------------------------------------------------------------------------
' Clamp a value to a given range
' ----------------------------------------------------------------------------
Function Clamp:Int(val:Int, minimum:Int, maximum:Int)

	If val < minimum
	
		Return minimum

	ElseIf val > maximum
	
		Return maximum

	Else
	
		Return val

	EndIf

End Function



' ----------------------------------------------------------------------------
' Clamp a RGB value to 0...255
' ----------------------------------------------------------------------------
Function ClampColor:Int(val:Int)

	If val < 0
	
		Return 0

	ElseIf val > 255
	
		Return 255

	Else
	
		Return val

	EndIf

End Function



' ----------------------------------------------------------------------------
' Calculates a Normal Map value at x,y with a 3x3 matrix
' ----------------------------------------------------------------------------
Function CalcNormal:Int(pixmap:TPixmap, x:Int, y:Int, normalsfactor:Float = 1.0, invY:Int = False)
	
	Local xm1:Int, xp1:Int, ym1:Int, yp1:Int
	Local tl:Int, tm:Int, tr:Int, ml:Int, mr:Int, bl:Int, bm:Int, br:Int
	Local vx:Float, vy:Float, vz:Float
	Local isq2:Float, sum:Float
	Local al:Float, ar:Float, at:Float, ab:Float
	Local m:Float
	Local r:Int, g:Int, b:Int, rgb:Int
	
	Local w:Int = pixmap.width
	Local h:Int = pixmap.Height
	
	' wrap pixmap
	If x > 0 Then xm1 = x - 1 Else xm1 = 0
	If x < W - 1 Then xp1 = x + 1 Else xp1 = W - 1
	If y > 0 Then ym1 = y - 1 Else ym1 = 0
	If y < H - 1 Then yp1 = y + 1 Else yp1 = H - 1
	
	' get the middle And the surrounding heights
	tl = GetHeight(pixmap, xm1, ym1, invY)
	tm = GetHeight(pixmap, x, ym1, invY)
	tr = GetHeight(pixmap, xp1, ym1, invY)
	ml = GetHeight(pixmap, xm1, y, invY)
	mr = GetHeight(pixmap, xp1, y, invY)
	bl = GetHeight(pixmap, xm1, yp1, invY)
	bm = GetHeight(pixmap, x, yp1, invY)
	br = GetHeight(pixmap, xp1, yp1, invY)
	
	vx = 0.0
	vy = 0.0
	vz = 1.0
	
	isq2 = 1.0 / Sqr(2.0)
	sum = 1.0 + isq2 + isq2
	
	al = (tl * isq2 + ml + bl * isq2) / sum
	ar = (tr * isq2 + mr + br * isq2) / sum
	at = (tl * isq2 + tm + tr * isq2) / sum
	ab = (bl * isq2 + bm + br * isq2) / sum
	
	vx = (al - ar) / (255.0)
	vy = (at - ab) / (255.0)

	m = Max(0, vx * vx + vy * vy)
	m = Min(m, 1.0)

	vz = Sqr(1.0 - m)

	If normalsfactor <> 0.0 Then
	
		vz = vz / normalsfactor
		m:Float = Sqr(vx * vx + vy * vy + vz * vz)
		vx = vx / m
		vy = vy / m
		vz = vz / m

	EndIf
	
	r = Normalize(vx, -1, 1, 0, 255)
	g = Normalize(vy, 1, -1, 0, 255)
	b = Normalize(vz, -1, 1, 0, 255)
	
	rgb = r * $10000 + g * $100 + b
	
	Return rgb
	
End Function



' ----------------------------------------------------------------------------
' Reads a bumpmap height value
' ----------------------------------------------------------------------------
Function GetHeight:Int(pixmap:TPixmap, x:Int, y:Int, invY:Int = False)

	If invY Then Return 255 - ReadPixel(pixmap, x, y) & $FF
	
	Return ReadPixel(pixmap, x, y) & $FF

End Function



' ----------------------------------------------------------------------------
' Normalize a value
' ----------------------------------------------------------------------------
Function Normalize:Float(value:Float = 128.0, vmin:Float = 0.0, vmax:Float = 255.0, nmin:Float = 0.0, nmax:Float = 1.0)
    
	Return ((value:Float - vmin:Float) / (vmax:Float - vmin:Float)) * (nmax:Float - nmin:Float) + nmin:Float
    
End Function



' ----------------------------------------------------------------------------
' Return R value of a given RGB value
' ----------------------------------------------------------------------------
Function GetR:Int(RGB:Int)
	
	Return RGB Shr 16 & %11111111
	
End Function



' ----------------------------------------------------------------------------
' Return G value of a given RGB value
' ----------------------------------------------------------------------------
Function GetG:Int(RGB:Int)
	
	Return RGB Shr 8 & %11111111
	
End Function



' ----------------------------------------------------------------------------
' Return B value of a given RGB value
' ----------------------------------------------------------------------------
Function GetB:Int(RGB:Int)
	
	Return RGB & %11111111
	
End Function



' ----------------------------------------------------------------------------
' Return R value of a given RGB value
' ----------------------------------------------------------------------------
Function GetA:Int(RGB:Int)
	
	Return rgb Shr 24 & %11111111
	
End Function



' ----------------------------------------------------------------------------
' Return RGB value of given R,G,B single values
' ----------------------------------------------------------------------------
Function CombineRGB:Int(r:Int, g:Int, b:Int)

	Return b | (g Shl 8) | (r Shl 16)
	
End Function



' ----------------------------------------------------------------------------
' Return ARGB value of given R,G,B,A single values
' ----------------------------------------------------------------------------
Function CombineRGBA:Int(r:Int, g:Int, b:Int, a:Int)

	Return b | (g Shl 8) | (r Shl 16) | (a Shl 24)
	
End Function



' ----------------------------------------------------------------------------
' Filter functions like in Photoshop
' ----------------------------------------------------------------------------
Function Filter:Int(a:Int, b:Int, F:String = "Average")

	If a > 255 Then a = 255 Else If a < 0 Then a = 0
		If b > 255 Then b = 255 Else If b < 0 Then b = 0

			Local c:Int

			Select f

				Case "Add"

					Return Min(255, (a + b))

				Case "Subtract"

					If (a + b) < 255 Then Return 0 Else Return (a + b) - 255

				Case "Average"

					Return (a + b) Shr 1

				Case "Multiply"

					Return (a * b) Shr 6

				Case "Overlay"

					If a < 128 Then Return (a * b) Shr 7 Else Return 255 - ((255 - a) * (255 - b) Shr 7)

				Case "Exclusion"

					Return a + b - (a * b Shr 7)

				Case "Negation"

					Return 255 - Abs(255 - a - b)

				Case "Difference"

					Return Abs(a - b)

				Case "Darken"

					If a < b Then Return a Else Return b

				Case "Lighten"

					If a > b Then Return a Else Return b

				Case "Screen"

					Return 255 - ((255 - a) * (255 - b) Shr 8)

				Case "Hardlight"

					If b < 128 Then Return (a * b) Shr 7 Else Return 255 - ((255 - b) * (255 - a) Shr 7)

				Case "Lineardodge"

					Return Min(a + b, 255)

				Case "Linearburn"

					Return (a + b) - 192

				Case "Phoenix"

					Return Min(a, b) - Max(a, b) + 255
					
				Case "Hardmix"

					If Filter(a, b, "VividLight") < 128 Then Return 0 Else Return 255

				Case "Vividlight"

					If a < 128 Then Return Filter(b, (2 * a), "Colorburn") Else Return Filter(b, (2 * (a - 128)), "Colordodge")

				Case "Pinlight"

					If a < 128 Then Return Filter(b, (2 * a), "Darken") Else Return Filter(b, (2 * (a - 128)), "Lighten")

				Case "Linearlight"

					If a < 128 Then Return Filter(b, (2 * a), "Linearburn") Else Return Filter(b, (2 * (a - 128)), "Lineardodge")

				Case "Softlight"

					c = a * b Shr 8
					Return (c + a * (255 - ((255 - a) * (255 - b) Shr 8) - c) Shr 8)

				Case "Colordodge"

					If b = 255 Then

						Return 255

					Else

						c = Floor((a Shl 8) / (255 - b))
						If c > 255 Then Return 255 Else Return c

					EndIf

				Case "Colorburn"

					If b = 0 Then c = 0 Else c = 255 - (((255 - a) Shl 8) / b)
					If c < 0 Then Return 0 Else Return c

				Case "Glow"

					If a = 255 Then

						c = 255

					Else

						c = b * b / (255 - a)
						If c > 255 Then Return 255

					EndIf

					Return c

			End Select

End Function



' ----------------------------------------------------------------------------
' Simple Greyscale: by Average and by Luminosity
' ----------------------------------------------------------------------------
Function Greyscale:Int(r:Int, g:Int, b:Int, f:String = "Average")

	Select f
	
		Case "Average" Return Int((r + g + b) / 3.0)

		Case "Luminosity" Return Int(0.21 * r + 0.72 * g + 0.07 * b)
	
	End Select

End Function



' ----------------------------------------------------------------------------
' Saves a Pixmap to a TGA File (32bit depth only!)
' ----------------------------------------------------------------------------
Function SavePixmapTGA(pixmap:TPixmap, filename:String, depth:Int = 32)

	Local width:Int = pixmap.width
	Local Height:Int = pixmap.Height
	
	Local x:Int, y:Int
	
	' add extension if missing
	If Lower(Right(filename, 4)) <> ".tga" Then filename:+".tga"
	
	Local f:TStream = WriteFile(filename)
	
	' header
	WriteByte(f, 0)          ' id length
	WriteByte(f, 0)          ' colormap type
	WriteByte(f, 2)          ' imagetype 2=rgb
	WriteShort(f, 0)         ' colormap index
	WriteShort(f, 0)         ' colormap numentries
	WriteByte(f, 0)          ' colormap size 
	WriteShort(f, 0)         ' x origin
	WriteShort(f, 0)         ' y origin
	WriteShort(f, width)     ' width
	WriteShort(f, Height)    ' height
	WriteByte(f, depth)      ' bit depth
	WriteByte(f, 8)          ' attributes
	
	For y = Height - 1 To 0 Step - 1
	
		For x = 0 To width - 1

			' Read pixmap data
			Local rgb:Int = ReadPixel(pixmap, x, y)
			Local r:Int = getR(rgb)
			Local g:Int = getG(rgb)
			Local b:Int = getB(rgb)
			Local a:Int = getA(rgb)
	
			Select depth
	
				Case 8

					' 8bit: RED channel only
					WriteByte(f, r)

				Case 24

					' 24bit: RGB channels only
					WriteByte(f, b)
					WriteByte(f, g)
					WriteByte(f, r)

				Case 32

					' 32bit: RGBA channels
					WriteByte(f, b)
					WriteByte(f, g)
					WriteByte(f, r)
					WriteByte(f, A)
	
			End Select
	
		Next

	Next
	
	CloseFile f

End Function



' ----------------------------------------------------------------------------
' Draws text with simple shadow
' ----------------------------------------------------------------------------
Function DrawShadowText(txt:String, x:Int, y:Int, r1:Int = 255, g1:Int = 255, b1:Int = 255, r2:Int = 0, g2:Int = 0, b2:Int = 0)

	SetColor r2, g2, b2
	DrawText txt, x + 1, y + 1

	SetColor r1, g1, b1
	DrawText txt, x, y

End Function